#this script provides an example for scoring leaves along a priori PC1
#to use either a priori PC2 or a priori PC3 change which file is read in 
#	(chc2Out('shapes_for_a_priori_PC2.chc'), skip=5)

setwd('~/A_priori_morphospace_analysis')
library(devtools)
library(ggplot2)
#use this command to install Momocs from source 
#devtools::install_github("vbonhomme/Momocs", build_vignettes=F)
library(Momocs)

#a function to combine Coo objects:
c.Coo <- function(..., recursive=FALSE){
     args <- list(...)
     res <- args[[1]] 
     res$coo <- do.call(c,     lapply(args, function(x) c(x$coo)))
     res$ldk <- do.call(c,     lapply(args, function(x) c(x$ldk)))
#     res$fac <- do.call(c,     lapply(args, function(x) c(x$fac)))

     res$fac <- do.call(rbind, lapply(args, function(x) x$fac))
     res
}

chc2Out('shapes_for_a_priori_PC1.chc', skip=5)->Axis1 #read in the file with the two reference shapes
def_ldk(Axis1, 2)->Axis1			#define the landmarks--for leaves top and bottom of each shape
factor<-rep('reference', 2)			#identify the factor of these shapes as reference
Axis1$fac<-as.data.frame(factor)
all_axis1<-Axis1
while(length(all_axis1)<=998){		#then multiply the shapes many times 
	c(all_axis1, Axis1)->all_axis1
}
coo_bookstein(all_axis1,1,2)->aligned		#align the reference shapes
coo_slide(aligned, ldk=1)-> aligned
Axis1F<-efourier(aligned, nb.h=30, norm=F)	#do the elliptical fourier analysis
PCA(Axis1F)->Axis1D						
plot3(Axis1D)								#look at the morphospace

#now score some leaves along this axis:
chc2Out('example_leaves.chc', skip=5)->leaves
panel(leaves, col='black')
slice(leaves, 1:10)->leaves			#take just the first 10 leaves in this file
def_ldk(leaves, 2)-> leaves			#define the landmarks--for leaves top and bottom of each shape
factor<-rep('leaf', 10)			#identify the factor of these shapes as reference
leaves$fac<-as.data.frame(factor)
coo_bookstein(leaves,1,2)-> leaves
coo_slide(leaves, ldk=1)-> leaves
stack(leaves)

PC_scores<-c()
for(i in 1:length(leaves)){
slice(leaves, i)->leaf1
c(leaf1, all_axis1)->dataset
coo_bookstein(dataset,1,2)->aligned
coo_slide(aligned, ldk=1)-> aligned
Axis1F<-efourier(aligned, nb.h=30, norm=F)
PCA(Axis1F)->Axis1D
#plot3(Axis1D)	#plot this if you want to see where the leaf falls visually
#sometimes, depending on where the leaf falls the morphospace 'flips' so that the 
#narrow leaves are on the other right. The next couple of lines make sure that 
#you always get a PC score with the right sign--i.e. that this doesn't affect
#the scores you're getting for your leaves
if(Axis1D$x[grep('Axis', row.names(Axis1D$x)),][1,1]>=0){	
	Axis1D$x[-grep('Axis', row.names(Axis1D$x)),1]*-1->PC1_score
}else{
Axis1D$x[-grep('Axis', row.names(Axis1D$x)),1]->PC1_score}
c(PC_scores, PC1_score)->PC_scores
print(i)
}

#the vector PC_Scores now contains an a priori PC1 score for each leaf
head(PC_scores)
